.nolist
include	\masm32\include\masm32rt.inc
.code

MulByte MACRO ToEax:REQ, mul:REQ	;works fine if the result is between 0 and 255
  mov eax, ToEax
  shl eax,8		; mov into AH
  db 0D5h,mul	; multiply AL
  EXITM <eax>
ENDM

GetCell MACRO Row:REQ, Col:REQ
  mov edx,offset RowLen
  mov ecx,MulByte([edx],Row)	; get pos of row
  add ecx,Col		; add pos of column
  add ecx,ecx		; multiply with four
  add ecx,ecx		; since table is dd
  mov edx,offset MyFlatBuffer
  EXITM <[edx+ecx]>
ENDM

MyFlatBuffer:
	dd 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28
	dd 29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53

RowLen	dd 7

start:	invoke SetConsoleTitle,chr$("Testing the AAM and AAD opcodes:")

	print chr$(13,10,"Getting the value of cell row:col in a flat buffer (0, 1, 2, ... n):",13,10)

	print chr$(13,10,"Each row of our table has ")
	mov eax,offset RowLen
	print str$([eax])
	print chr$(" elements:",13,10)

	print chr$(13,10,"Row 0:",9,"0,1,2,3,4,5,6")
	print chr$(13,10,"Row 1:",9,"7,8,9,10,11,12,13")
	print chr$(13,10,"Row 2:",9,"14,15,16,17,18,19,20")
	print chr$(13,10,"Row 3:",9,"21,22,23,24,25,26,27")
	print chr$(13,10,"Row 4:",9,"28,29,30,31,32,33,34")
	print chr$(13,10) ; OK, the fun starts here

	print chr$(13,10,"Cell 0:0 = ")
	print str$(GetCell(0,0))

	print chr$(13,10,"Cell 1:1 = ")
	print str$(GetCell(1,1))

	print chr$(13,10,"Cell 2:3 = ")
	print str$(GetCell(2,3))

	print chr$(13,10,"Cell 4:6 = ")
	print str$(GetCell(4,6))

	print chr$(13,10)
	print chr$(13,10,"Usage:")
	print chr$(13,10,"print chr$",40,"13,10,",34,"Cell 2:3 = ",34,41)
	print chr$(13,10,"print str$(GetCell(2,3))",13,10)

	call ret_key
	invoke ExitProcess,0
end start
; OPT_SUSY CONSOLE	; AsmBuild option: assemble as console app
